
var ELDumperOutput = {
	txt_value: "",
	html_value: "",
arr_name: null,
arr_id: null,
arr_disabled: null,
arr_url: null,
arr_desc: null,
arr_bwsr: null,
	
	showDump: function() {
		if (window.opener.gExtensionsView != null) {
			// Opened from the add-ons window
			var bundle = document.getElementById("bundle_eldumper");
			var app_info = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
			var elem = document.getElementById("eld_outbox");
			var html_elem = document.getElementById("eld_html");
			html_elem.hidden = false;
			var show_desc_elem = document.getElementById("eld_show_desc");
			show_desc_elem.hidden = false;
			var show_id_elem = document.getElementById("eld_show_id");
			show_id_elem.hidden = false;
			var show_total_elem = document.getElementById("eld_show_total");
			show_total_elem.hidden = false;
			var show_url = document.getElementById("eld_show_url");
			show_url.hidden = false;
			var show_date = document.getElementById("eld_show_date");
			show_date.hidden = false;
			var items = [];
			var children = window.opener.gExtensionsView.children;
			var item;
			var out_txt = "";
			var out_txt_desc = "";
			var out_html = "<ul>";
			var out_html_desc = "<ul>";
			var print_html = "<ul>";
			var print_html_desc = "<ul>";
			var url;
ELDumperOutput.arr_name = Array();
ELDumperOutput.arr_id = Array();
ELDumperOutput.arr_disabled = Array();
ELDumperOutput.arr_url = Array();
ELDumperOutput.arr_desc = Array();
var elem_total = document.getElementById("lbl_total");
elem_total.value += " " + children.length;
			for (var i = 0; i < children.length; ++i) {
				item = window.opener.gExtensionManager.getItemForID(window.opener.getIDFromResourceURI(children[i].id));
ELDumperOutput.arr_name[i] = item.name + " " + item.version;
ELDumperOutput.arr_id[i] = item.id;
if (children[i].isDisabled) {
	ELDumperOutput.arr_disabled[i] = "(" + bundle.getString("disabled") + ")";
}
else {
	ELDumperOutput.arr_disabled[i] = "";
}
ELDumperOutput.arr_url[i] = ELDumperOutput.trim(children[i].getAttribute("homepageURL"));
ELDumperOutput.arr_desc[i] = ELDumperOutput.trim(children[i].getAttribute("description"));
				
				// Text
				out_txt += "- " + item.name + " " + item.version + "\n";
				out_txt_desc += "- " + item.name + " " + item.version + "\n";
				if (children[i].isDisabled) {
					out_txt += "     (" + bundle.getString("disabled") + ")\n";
					out_txt_desc += "     (" + bundle.getString("disabled") + ")\n";
				}
				if (ELDumperOutput.trim(children[i].getAttribute("description")) != "") {
					out_txt_desc += "     " + ELDumperOutput.trim(children[i].getAttribute("description")) + "\n";
				}

				// HTML (and print)
				out_html += "\n<li>";
				out_html_desc += "\n<li>";
				print_html += "\n<li>";
				print_html_desc += "\n<li>";
				url = ELDumperOutput.trim(children[i].getAttribute("homepageURL"));
				if (url != "") {
					out_html += "<a href=\"" + url + " \">" + item.name + " " + item.version + "</a>";
					out_html_desc += "<a href=\"" + url + " \">" + item.name + " " + item.version + "</a>";
				}
				else {
					out_html += item.name + " " + item.version;
					out_html_desc += item.name + " " + item.version;
				}
				print_html += item.name + " " + item.version;
				print_html_desc += item.name + " " + item.version;
				if (children[i].isDisabled) {
					out_html += "\n\t<br />(" + bundle.getString("disabled") + ")";
					out_html_desc += "\n\t<br />(" + bundle.getString("disabled") + ")";
					print_html += "\n\t<br />(" + bundle.getString("disabled") + ")";
					print_html_desc += "\n\t<br />(" + bundle.getString("disabled") + ")";
				}
				if (ELDumperOutput.trim(children[i].getAttribute("description")) != "") {
					out_html_desc += "\n\t<br />" + ELDumperOutput.trim(children[i].getAttribute("description")) + "\n";
					print_html_desc += "\n\t<br />" + ELDumperOutput.trim(children[i].getAttribute("description")) + "\n";
				}
				out_html += "</li>";
				out_html_desc += "</li>";
				print_html += "</li>";
				print_html_desc += "</li>";
			}
			out_html += "\n</ul>";
			out_html_desc += "\n</ul>";
			print_html += "\n</ul>";
			print_html_desc += "\n</ul>";
			
			var out_info = "";
			var out_info_html = "";
			out_info += bundle.getString("appl") + ": " + app_info.name + " " + app_info.version + " (" + app_info.appBuildID + ")\n";
			out_info_html += bundle.getString("appl") + ": " + app_info.name + " " + app_info.version + " (" + app_info.appBuildID + ")<br />\n";
			var app_info2 = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime);
			out_info += bundle.getString("os") + ": " + app_info2.OS + " (" + app_info2.XPCOMABI + ")\n";
			out_info_html += bundle.getString("os") + ": " + app_info2.OS + " (" + app_info2.XPCOMABI + ")";
ELDumperOutput.arr_bwsr = Array();
ELDumperOutput.arr_bwsr[0] = bundle.getString("appl") + ": " + app_info.name + " " + app_info.version + " (" + app_info.appBuildID + ")";
ELDumperOutput.arr_bwsr[1] = bundle.getString("os") + ": " + app_info2.OS + " (" + app_info2.XPCOMABI + ")";
			
			ELDumperOutput.txt_value = out_info + "\n" + out_txt;
			ELDumperOutput.txt_desc_value = out_info + "\n" + out_txt_desc;
			ELDumperOutput.html_value = "<p>" + out_info_html + "</p>\n\n" + out_html;
			ELDumperOutput.html_desc_value = "<p>" + out_info_html + "</p>\n\n" + out_html_desc;
			ELDumperOutput.print_value = "<p>" + out_info_html + "</p>\n\n" + print_html;
			ELDumperOutput.print_desc_value = "<p>" + out_info_html + "</p>\n\n" + print_html_desc;

//			elem.value = ELDumperOutput.txt_value;
			var ops = ELDumperOutput.loadPrefs();
			if (!ops["html"] && !ops["desc"]) {
				elem.value = ELDumperOutput.txt_value;
			}
			else if (ops["html"] && !ops["desc"]) {
				elem.value = ELDumperOutput.html_value;
			}
			else if (ops["html"] && ops["desc"]) {
				elem.value = ELDumperOutput.html_desc_value;
			}
			else {
				elem.value = ELDumperOutput.txt_desc_value;
			}

elem.value = ELDumperOutput.buildOutput(ops["html"], ops["desc"], ops["id"], true);
		}
		else {
			// Opened from the url "chrome://mozapps/content/extensions/extensions.xul"
			var elem = document.getElementById("eld_outbox");
			var ext_mngr = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
			var app_info = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
			var bundle = document.getElementById("bundle_eldumper");
			
			// Get list of disabled add-ons
			var incompatible_count = new Object();
			var incompatible = new Object();
			incompatible = ext_mngr.getIncompatibleItemList(app_info.ID, app_info.version, 2, true, incompatible_count);
			incompatible_count = incompatible_count.value;
			var incompatible_arr = new Array();
			for (var j = 0; j < incompatible_count; j++) {
				incompatible_arr[j] = incompatible[j].id;
			}
			
			var count = new Object();
			var items = new Object();
			var items_res = ext_mngr.getItemList(2, count, items);
			count = count.value;
			var item;
			var out = "";
			for (var i = 0; i < count; ++i) {
				item = items_res[i];
				out += "- " + item.name + " " + item.version + "\n";
				if (incompatible_arr.lastIndexOf(item.id) >= 0) {
					out += "     (" + bundle.getString("disabled") + ")\n";
				}
			}
			this.output = out;
			
			
			var out_info = "";
			out_info += bundle.getString("appl") + ": " + app_info.name + " " + app_info.version + " (" + app_info.appBuildID + ")\n";
			var app_info2 = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime);
			out_info += bundle.getString("os") + ": " + app_info2.OS + " (" + app_info2.XPCOMABI + ")\n";
			
			elem.value = out_info + "\n" + out;
			txt_value = elem.value;
		}
	},
	
	load: function() {
		var ops = ELDumperOutput.loadPrefs();
		var elem = document.getElementById("eld_html");
		elem.checked = ops["html"];
		elem = document.getElementById("eld_show_desc");
		elem.checked = ops["desc"];
		elem = document.getElementById("eld_show_id");
		elem.checked = ops["id"];
		elem = document.getElementById("eld_show_total");
		elem.checked = ops["total"];
elem = document.getElementById("eld_show_url");
elem.checked = ops["url"];
elem = document.getElementById("eld_show_date");
elem.checked = ops["date"];
	},

	loadPrefs: function() {
		var arr = Array();
		arr["html"] = false;
		arr["desc"] = false;
		arr["id"] = false;
		arr["total"] = false;
		arr["url"] = false;
		arr["date"] = false;
		try {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			arr["html"] = prefs.getBoolPref("eldumper.html");
			arr["desc"] = prefs.getBoolPref("eldumper.desc");
			arr["id"] = prefs.getBoolPref("eldumper.show_id");
			arr["total"] = prefs.getBoolPref("eldumper.show_total");
			arr["url"] = prefs.getBoolPref("eldumper.show_url");
			arr["date"] = prefs.getBoolPref("eldumper.show_date");
			return arr;
		}
		catch (e) {
			return arr;
		}
	},
	
	copy: function() {
		var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
		var area = document.getElementById("eld_outbox");
		clipboard.copyString(area.value);
	},
	
	saveFile: function() {
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.appendFilters(nsIFilePicker.filterText | nsIFilePicker.filterHTML | nsIFilePicker.filterAll);
			fp.init(window, "", nsIFilePicker.modeSave);
			var res = fp.show();
			if ((res == nsIFilePicker.returnOK) || (res == nsIFilePicker.returnReplace)) {
				var file = fp.file;
				var area = document.getElementById("eld_outbox");
				var sFileContent = area.value;
				var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
				outputStream.init(fp.file, 0x02 | 0x08 | 0x20, 777, 0);
				var result = outputStream.write(sFileContent, sFileContent.length);
				outputStream.close();
			}
		}
		catch (e) {
			alert(e.message);
		}
	},
	
	printOutput: function() {
		var area = document.getElementById("eld_outbox");
		var doc_print = document.getElementById("eld_printbox").contentDocument;
		var iframe_body = doc_print.getElementsByTagName('body')[0];
		var show_desc_elem = document.getElementById("eld_show_desc");
		var show_id_elem = document.getElementById("eld_show_id");
/*		if (show_desc_elem.checked) {
			iframe_body.innerHTML = ELDumperOutput.print_desc_value;
		}
		else {
			iframe_body.innerHTML = ELDumperOutput.print_value;
		}*/
iframe_body.innerHTML = ELDumperOutput.buildOutput(true, show_desc_elem.checked, show_id_elem.checked, false);
		document.getElementById("eld_printbox").contentWindow.print();
	},
	
/*	toggleHTML: function() {
		var elem = document.getElementById("eld_outbox");
		var html_elem = document.getElementById("eld_html");
		if (html_elem.checked) {
			// Show HTML
			elem.value = ELDumperOutput.html_value;
		}
		else {
			// Show text
			elem.value = ELDumperOutput.txt_value;
		}
	},*/

	toggleOutput: function() {
		var elem = document.getElementById("eld_outbox");
		var html_elem = document.getElementById("eld_html");
		var show_desc_elem = document.getElementById("eld_show_desc");
		var show_id_elem = document.getElementById("eld_show_id");
/*		if (html_elem.checked && !show_desc_elem.checked) {
			// Show HTML
			elem.value = ELDumperOutput.html_value;
		}
		else if (html_elem.checked && show_desc_elem.checked) {
			// Show HTML and descriptions
			elem.value = ELDumperOutput.html_desc_value;
		}
		else if (!html_elem.checked && !show_desc_elem.checked) {
			// Show text
			elem.value = ELDumperOutput.txt_value;
		}
		else {
			// Show text and descriptions
			elem.value = ELDumperOutput.txt_desc_value;
		}*/
		elem.value = ELDumperOutput.buildOutput(html_elem.checked, show_desc_elem.checked, show_id_elem.checked, true);
	},
	
	
	buildOutput: function(html, desc, id, links) {
		var out = "";
		if (html) {
			out += "<ul>";
		}
		var elem_url = document.getElementById("eld_show_url");
		for (var i=0; i<ELDumperOutput.arr_name.length; ++i) {
			out += "\n";
			if (html) {
				out += "<li>";
			}
			// Name
			if (html && links && (ELDumperOutput.arr_url[i] != "")) {
				out += "<a href=\"" + ELDumperOutput.arr_url[i] + "\">" + ELDumperOutput.arr_name[i] + "</a>";
			}
			else {
				if (!html) {
					out += "- ";
				}
				out += ELDumperOutput.arr_name[i];
			}
			// ID
			if (id) {
				out += "\n\t";
				if (html) {
					out += "<br />";
				}
				out += ELDumperOutput.arr_id[i];
			}
			// Disabled
			if (ELDumperOutput.arr_disabled[i] != "") {
				out += "\n\t";
				if (html) {
					out += "<br />";
				}
				out += ELDumperOutput.arr_disabled[i];
			}
			// URL
			if (elem_url.checked && (ELDumperOutput.arr_url[i] != "")) {
				out += "\n\t";
				if (links && html) {
					out += "<br /><a href=\"" + ELDumperOutput.arr_url[i] + "\">" + ELDumperOutput.arr_url[i] + "</a>";
				}
				else if (html) {
					out += "<br />" + ELDumperOutput.arr_url[i];
				}
				else {
					out += ELDumperOutput.arr_url[i];
				}
			}
			// Description
			if (desc && (ELDumperOutput.arr_desc[i] != "")) {
				out += "\n\t";
				if (html) {
					out += "<br />";
				}
				out += ELDumperOutput.arr_desc[i];
			}

			if (html) {
				out += "\n</li>"
			}
		}
		if (html) {
			out += "\n</ul>";
		}

		// Application info
		var out_app = ELDumperOutput.arr_bwsr[0];
		if (html) {
			out_app += "<br />";
		}
		out_app += "\n";
		out_app += ELDumperOutput.arr_bwsr[1];
		if (html) {
			out_app = "<p>" + out_app + "</p>\n";
		}
		// Date
		var elem_date = document.getElementById("eld_show_date");
		if (elem_date.checked) {
			var out_date = this.builDate();
			if (html) {
				out_date = "<p>" + out_date + "</p>\n";
			}
			else {
				out_date = "\n" + out_date;
			}
			out_app += "\n" + out_date;
		}
		// Total number of items
		var elem_total = document.getElementById("eld_show_total");
		if (elem_total.checked) {
			var out_total = elem_total.label + ": " + ELDumperOutput.arr_name.length;
			if (html) {
				out_total = "<p>" + out_total + "</p>\n";
			}
			else {
				out_total = "\n" + out_total;
			}
			out_app += "\n" + out_total;
		}
		
		out = out_app + "\n" + out;
		return out;
	},
	
	
	builDate: function() {
		var dt = new Date();
		var format = document.getElementById("bundle_eldumper").getString("eld-date_format");
		format = format.replace('[M]', document.getElementById("bundle_eldumper").getString("eld-month_long_" + dt.getMonth()));
		format = format.replace('[D]', dt.getDate());
		format = format.replace('[Y]', dt.getYear() + 1900);
		return format;
	},

	
	trim: function(s) {
		while (s.substring(0, 1) == ' ') {
			s = s.substring(1, s.length);
		}
		while (s.substring(s.length-1, s.length) == ' ') {
			s = s.substring(0, s.length-1);
		}
		return s;
	}
};