
var ELDumperOps = {
	load: function() {
		var ops = ELDumperOps.loadPrefs();
		var elem = document.getElementById("cb_html");
		elem.checked = ops["html"];
		elem = document.getElementById("cb_desc");
		elem.checked = ops["desc"];
		elem = document.getElementById("cb_id");
		elem.checked = ops["id"];
		elem = document.getElementById("cb_total");
		elem.checked = ops["total"];
		elem = document.getElementById("cb_url");
		elem.checked = ops["url"];
		elem = document.getElementById("cb_date");
		elem.checked = ops["date"];
	},
	
	loadPrefs: function() {
		var arr = Array();
		arr["html"] = false;
		arr["desc"] = false;
		arr["id"] = false;
		try {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			arr["html"] = prefs.getBoolPref("eldumper.html");
			arr["desc"] = prefs.getBoolPref("eldumper.desc");
			arr["id"] = prefs.getBoolPref("eldumper.show_id");
			arr["total"] = prefs.getBoolPref("eldumper.show_total");
			arr["url"] = prefs.getBoolPref("eldumper.show_url");
			arr["date"] = prefs.getBoolPref("eldumper.show_date");
			return arr;
		}
		catch (e) {
			return arr;
		}
	},
	
	save: function() {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var elem = document.getElementById("cb_html");
		prefs.setBoolPref("eldumper.html", elem.checked);
		elem = document.getElementById("cb_desc");
		prefs.setBoolPref("eldumper.desc", elem.checked);
		elem = document.getElementById("cb_id");
		prefs.setBoolPref("eldumper.show_id", elem.checked);
		elem = document.getElementById("cb_total");
		prefs.setBoolPref("eldumper.show_total", elem.checked);
		elem = document.getElementById("cb_url");
		prefs.setBoolPref("eldumper.show_url", elem.checked);
		elem = document.getElementById("cb_date");
		prefs.setBoolPref("eldumper.show_date", elem.checked);
		
		window.close();
	}
};
